/*  
 
    enRay, a realtime raytracer written in C
    Copyright (C) 2002  Antonis Stampoulis

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 */

#ifndef __PRIMITIVES_H__
#define __PRIMITIVES_H__

Primitive NewSphere    (float x, float y, float z, float radius);
Primitive NewDummy    (float x, float y, float z);
void      ChangeSphere (void *, float x, float y, float z, float radius);

Primitive NewPlane     (float nx, float ny, float nz, float x0, float y0, float z0);
void      ChangePlane  (void *, float nx, float ny, float nz, float x0, float y0, float z0);

Primitive NewImplicit (float boundingSphereCenterX, float boundingSphereCenterY, float boundingSphereCenterZ,
                       float boundingSphereRadius,  float (*ImplicitFunction)(float,float,float),
                       float ParameterStep, int RefinementSteps);
void MoveImplicit (void *, float boundingSphereCenterX, float boundingSphereCenterY, float boundingSphereCenterZ);


Primitive NewMesh (void);
void MeshMaterialPointer (void *, Material *);
Primitive NewZBufMap (int, int);

#endif

